//1999 raulrita
//Http://www.evora.net/raulrita
//e-mail: raulrita@mail.evora.net
//Versao 1.0

unit BrowseIt;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ShlObj;

type
  TBrowseIt = class(TComponent)
  private
    DDirectoria : String;
    TTitulo     : String;
    FBrowseInfo : TBrowseInfo;
  public
    Procedure Execute ( Form : TForm );
    Procedure About;
  published
    property Directoria : string read DDirectoria write DDirectoria;
    property Titulo     : string read TTitulo write TTitulo;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Freeware', [TBrowseIt]);
end;

function BrowseCallback(Wnd: HWND; uMsg: UINT; lParam, lpData: LPARAM): Integer stdcall;
begin
  Result := 0;

  if uMsg = BFFM_INITIALIZED then
    with TBrowseIt( lpData ) do
     begin
       SendMessage( Wnd , BFFM_SETSTATUSTEXT , 1 , Longint( PChar( ' Iniciado em ' + Directoria ) ) );
       if Length( Directoria ) > 0 then
         SendMessage( Wnd , BFFM_SetSelection , 1 , Longint( PChar( Directoria ) ) );
     end;
end;

Procedure TBrowseIt.About;
var Temp : String;
begin
  temp:= '1999 raulrita';
  temp:= temp + #13'http://www.evora.net/raulrita';
  temp:= temp + #13'e-mail: raulrita@mail.evora.net';
  temp:= temp + #13'Rua Dr.Egas Moniz 55, 7000 vora, Portugal';
  ShowMessage(Temp);
end;

Procedure TBrowseIt.Execute ( Form : TForm );
var Buffer      : PChar;
    List        : PItemIDList;
begin

  GetMem(Buffer, MAX_PATH);

  with FBrowseInfo do
    begin
      hwndOwner := Form.Handle;
      pidlRoot  := nil;
      lpszTitle := PChar( TTitulo );
      ulFlags   := BIF_RETURNONLYFSDIRS + BIF_STATUSTEXT;
      lpfn      := BrowseCallback;
      lParam    := Longint( Self );
    end;

  list := ShBrowseForFolder( FBrowseInfo );

  if not ( List = nil ) then
    begin
      SHGetPathFromIDList( List , Buffer );
      DDirectoria := Buffer;
    end;
    
  FreeMem(Buffer);

end;

end.
